

#property indicator_separate_window
#property indicator_buffers     3
#property indicator_color1      LimeGreen
#property indicator_color2      Red
#property indicator_color3      Red
#property indicator_width1      2
#property indicator_width2      2
#property indicator_width3      2
#property indicator_level1      200
#property indicator_level2      100
#property indicator_level3      0
#property indicator_level4     -100
#property indicator_level5     -200
#property indicator_levelcolor  MediumOrchid

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern double BandsPeriod     = 20;
extern int    BandsPrice      = 0;
extern int    BandsMaMode     = MODE_SMA;
extern double BandsDeviations = 2.0;

//
//
//
//
//

double Buffer[];
double BufferDa[];
double BufferDb[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
    IndicatorBuffers(4);
    SetIndexBuffer(0,Buffer);
    SetIndexBuffer(1,BufferDa);
    SetIndexBuffer(2,BufferDb);
    SetIndexBuffer(3,trend);
   
   //
   //
   //
   //
   //
    
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
      
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+"   BB Percent");
 return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//
//
//
//
//


int start() 
{
   int counted_bars=IndicatorCounted();
   int i,j,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-1,Bars-counted_bars-1);
         if (returnBars) { Buffer[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      if (trend[limit] == -1) ClearPoint(limit,BufferDa,BufferDb);
      for(i = limit; i >= 0; i--)
      {
      
      double sum = 0.0;
      double ma  = iMA(NULL,0,BandsPeriod,0,0,BandsPrice,i);
      
      for(j=0; j<BandsPeriod; j++)
      {
      double pr  = iMA(NULL,0,1,0,MODE_SMA,BandsPrice,i+j);
             sum+=(pr-ma)*(pr-ma);
      }
      
      //
      //
      //
      //
      //
      
      double StdDev = MathSqrt(sum/BandsPeriod);
      double Upper  = ma + (StdDev*BandsDeviations);
      double Lower  = ma - (StdDev*BandsDeviations);
      double diff   = (Upper-Lower)/2;
              if (diff != 0)
                   Buffer[i] = 100*(Close[i] - ma);
              else Buffer[i] = 0;
                
             //
             //
             //
             //
             //
                
             BufferDa[i] = EMPTY_VALUE;
             BufferDb[i] = EMPTY_VALUE;
             trend[i]    = trend[i+1];
                if (Buffer[i] > Buffer[i+1]) trend[i] =  1;
                if (Buffer[i] < Buffer[i+1]) trend[i] = -1;
                if (trend[i]== -1) PlotPoint(i,BufferDa,BufferDb,Buffer);
      
      }

   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (trend[limit]==-1) ClearPoint(limit,BufferDa,BufferDb); 
   for (i=limit; i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);
          Buffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPeriod,BandsPrice,BandsMaMode,BandsDeviations,0,y);
          trend[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPeriod,BandsPrice,BandsMaMode,BandsDeviations,3,y);
          BufferDa[i] = EMPTY_VALUE; 
          BufferDb[i] = EMPTY_VALUE;
            
          //
          //
          //
          //
          //
            
   }
   for(i=limit; i>=0; i--) if (trend[i]== -1) PlotPoint(i,BufferDa,BufferDb,Buffer);
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
   
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

